/* File: palindrome.cpp
 *
 * A program that reads a file of English words, then prints out all
 * the palindromic words.
 */
#include <iostream>
#include <string>
#include <fstream>
#include "simpio.h"
using namespace std;

bool isPalindrome(string text);

int main() {
	/* Open the file for reading.  We really should check whether
	 * the file is open before proceeding.
	 */
	string file = "dictionary.txt";
	ifstream input(file.c_str());
	
	/* Read each line of the file and print out those that are palindromes. */
	string line;
	while (getline(input, line)) {
		if (isPalindrome(line)) {
			cout << line << endl;
		}
	}
	
	return 0;
}

/* Returns whether the given string is a palindrome. */
bool isPalindrome(string text) {
	/* All characters of length 0 or length 1 are guaranteed to
	 * be palindromes.
	 */
	if (text.length() <= 1) {
		return true;
	}
	/* If the first and last character of the string aren't the same,
	 * the string cannot be a palindrome.
	 */
	else if (text[0] != text[text.length() - 1]) {
		return false;
	}
	/* Otherwise, this string is a palindrome precisely when the middle
	 * characters are a palindrome.
	 */
	else {
		return isPalindrome(text.substr(1, text.length() - 2));
	}
}




